var factory = function ( $filter ) {

    'use strict';

    return function () {

        return [ {
            headerName: '',
            field: 'alertMarker',
            width: 6,
            suppressResize: true,
            suppressSorting: true,
            suppressMenu: true,
            cellClass: 'ag-cell-alert',
            cellRenderer: function ( param ) {

                return '<div class="ag-cell-alert-' + param.value + '"></div>';

            }
        }, {
            headerName: 'Type',
            field: 'alert',
            width: 40
        }, {
            headerName: 'Date',
            field: 'date',
            sort: 'asc',
            width: 200,
            headerClass: 'sortable',
            cellRenderer: function ( param ) {

                return $filter( 'date' )( param.value, 'dd.MMM.yyyy HH:mm:ss:sss' );

            }
        }, {
            headerName: 'Action',
            field: 'action',
            width: 100,
            headerClass: 'sortable'
        }, {
            headerName: 'Method',
            field: 'method',
            width: 100,
            headerClass: 'sortable'
        }, {
            headerName: 'Url',
            field: 'url',
            width: 300,
            headerClass: 'sortable'
        }, {
            headerName: 'Headers',
            field: 'headers',
            width: 300,
            headerClass: 'sortable',
            cellRenderer: function ( param ) {

                return $filter( 'json' )( param.value );

            }
        }, {
            headerName: 'Data',
            field: 'data',
            width: 300,
            headerClass: 'sortable',
            cellRenderer: function ( param ) {

                return $filter( 'json' )( param.value );

            }
        } ];

    };

};

angular.module( 'KlickFlupp.console' ).factory(
    'consoleGridColumnsFactory',
    [
        '$filter',
        factory
    ]
);