var factory = function ( $q, requestService ) {

    'use strict';

    var request = function ( config ) {

        requestService.addRequest( config );

        return config;

    };

    var requestError = function ( rejection ) {

        return $q.reject( rejection );

    };

    var response = function ( resp ) {

        return resp || $q.when( resp );

    };

    var responseError = function ( rejection ) {

        return $q.reject( rejection );

    };

    return {
        request: request,
        requestError: requestError,
        response: response,
        responseError: responseError
    };

};

angular.module( 'KlickFlupp.console' ).factory(
    'interceptorServiceFactory',
    [
        '$q',
        'RequestService',
        factory
    ]
);