var Service = function ( consoleDataFactory, localStorageService ) {

    'use strict';

    var that = this,
        init = function () {

            var requests = that._localStorageService.get( 'requests' );

            if ( requests && angular.isArray( requests ) ) {

                that._requests.push.apply( that._requests, requests );

            }

        };

    this._consoleDataFactory = consoleDataFactory;
    this._localStorageService = localStorageService;
    this._isEnabled = false;
    this._requests = [];

    init();

};

Service.prototype = {

    get isEnabled() {

        return this._isEnabled;

    },

    set isEnabled( value ) {

        this._isEnabled = value;

    },

    get requests() {

        return this._requests;

    },

    set requests( value ) {

        this._requests = value;

    },

    addRequest: function ( requestConfig ) {

        var request = this._consoleDataFactory( requestConfig, 'Request' );

        this._requests.push( request );
        this._localStorageService.set( 'requests', this._requests );

    },

    clear: function () {

        this._requests.length = 0;
        this._localStorageService.clearAll();

    }

};

angular.module( 'KlickFlupp.console' ).service(
    'RequestService',
    [
        'consoleDataFactory',
        'localStorageService',
        Service
    ]
);