// http://plnkr.co/edit/Zi2f0EPxmtEUmdoFR63B?p=preview
var directive = function ( $document ) {

    'use strict';

    return {
        restrict: 'E',
        replace: true,
        link: function ( $scope, $element, $attributes ) {

            var resizeVertical = function ( pageX ) {

                var x = pageX;

                if ( x > (window.innerWidth - 200) ) {
                    x = window.innerWidth - 200;
                }

                if ( x < 200 ) {
                    x = 200;
                }

                $element.css( {
                    left: x + 'px'
                } );

                $( $attributes.resizerLeft ).css( {
                    width: x + 'px'
                } );

                $( $attributes.resizerRight ).css( {
                    left: (x + parseInt( $attributes.resizerWidth )) + 'px'
                } );

            };

            var resizeHorizontal = function ( pageY ) {

                var y = window.innerHeight - pageY;

                $element.css( {
                    bottom: y + 'px'
                } );

                $( $attributes.resizerBottom ).css( {
                    height: y + 'px'
                } );

            };

            var resize = function ( pageX, pageY ) {

                if ( $attributes.resizer === 'vertical' ) {

                    resizeVertical( pageX );

                } else {

                    resizeHorizontal( pageY );

                }

            };

            var mouseMove = function ( event ) {

                resize( event.pageX, event.pageY );

            };

            var mouseUp = function () {

                $document.unbind( 'mousemove', mouseMove );
                $document.unbind( 'mouseup', mouseUp );

            };

            $element.on( 'mousedown', function ( event ) {
                event.preventDefault();

                $document.on( 'mousemove', mouseMove );
                $document.on( 'mouseup', mouseUp );
            } );

            $( window ).on( 'resize', function () {

                resize( $( $attributes.resizerLeft ).width(), $( $attributes.resizerBottom ).height() );

            } );

        }

    }

};

angular.module( 'KlickFlupp.console' ).directive(
    'cfResizer',
    [
        '$document',
        directive
    ]
);